<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Graph</title>
</head>
<body>
  <h1>Please look at the console output to see the log of work with custom graph. Thanks!</h1>

<script>

  class CustomGraph {

    // nodesRelationsArr is an array of objects like:
    //
    // [
    //   {
    //     node: someNode,
    //     relationsArray: [
    //       {node: relationNode1,
    //        relation: 0
    //        },
    //       {node:relationNode2,
    //       relation: 1
    //       },
    //       {node: relationNode3,
    //       relation: 3
    //       }
    //     ]
    //   },
    //...
    // ]
    constructor(nodesRelationsArr) {
      this.nodesRelationsArray = nodesRelationsArr;
      // e.g. all the relations for one node must be included into its relationArray !
      this.lastCountedWayBetweenNodes = [];
      this.checkedNodes = []; //global array contains list of checked nodes while counting way
    };

    // returns array of relation objects
    getNodesRelationsArray() {
      return this.nodesRelationsArray;
    }

    // returns node by given ndoe name
    // returns null if node was not found
    getNode(node) {
      for(let i=0; i < this.nodesRelationsArray.length; i++){
        if (this.nodesRelationsArray[i].node === node){
          return this.nodesRelationsArray[i];
        }
      }
      return null;
    };

    // returns array of neighbours for given node
    // or null if there is no such node
    getNeighbours(node) {
      if (this.nodesRelationsArray.length === 0) {
        return null;
      }
      for (let i = 0; i < this.nodesRelationsArray.length; i++) {
        if (this.nodesRelationsArray[i].node === node) {
          return this.nodesRelationsArray[i].relationsArray;
        }
      }
      return null;
    }


    // add new node with known relations
    // return true if node has been added (false otherwise)
    addNewNode(newNode) {
      for(let i = 0; i < this.nodesRelationsArray.length; i++){
        if (this.nodesRelationsArray[i].node === newNode.node){
          return false;
        }
      }
      this.nodesRelationsArray.push(newNode);
      return true;
    }

    // add new relation between given nodes
    // if node1 doesn't exists, returns false
    addNewRelation(node1, node2, relatio) {
      for (let i = 0; i < this.nodesRelationsArray.length; i++) {
        if (this.nodesRelationsArray[i].node === node1) {
          this.nodesRelationsArray[i].relationsArray.push({node: node2, relation: relatio});
          return true;
        }
      }
      return false;
    }

    //delete given node if exists
    // if given node doesn't exists return false
    deleteNode(node) {
      let deletedAtLeastOnce = false;
      let len = this.nodesRelationsArray.length;
      for (let i = 0; i < len; i++) {
        if (this.nodesRelationsArray[i].node === node) {
          this.nodesRelationsArray.splice(i, 1);
          deletedAtLeastOnce = true;
        }
      }
      return deletedAtLeastOnce;
    }

    // delete given relation between two nodes
    // return true if at least one relation found and deleted
    deleteRelation(node1, node2, rel) {
      let len = this.nodesRelationsArray.length;
      let deletedAtLeastOnce = false;
      for (let i = 0; i < len; i++) {
        if (this.nodesRelationsArray[i].node === node1) {
          let lenRelation = this.nodesRelationsArray[i].relationsArray.length;
          let relArr = this.nodesRelationsArray[i].relationsArray;
          for (let j = 0; j < lenRelation; j++) {
            if (relArr[j].node === node2 && relArr[j].relation === rel) {
              // for (let k = j; k < lenRelation - 1; k++) {
              //   relArr[k] = relArr[k + 1];
              // }
              relArr.splice(j, 1);
              deletedAtLeastOnce = true;
              // break;
            }
          }
        }
      }
      return deletedAtLeastOnce;
    }

    // expands graph to the possible ways
    expandGraph(node1, node2) {
      console.log('Trying to expand graph...');
      let graphsArr = [];
      let nodes = this.nodesRelationsArray;
      for(let i = 2; i < nodes.length; i++){
        console.log('Trying to get permutations for k=' + i);
        let permutations = this.getPermutations(nodes,i);
        console.log('permutations size = ' + permutations.length);
        for(let j = 0; j < permutations.length; j++){
          let currentSequence = permutations[j];
          console.log('current sequence: ' + currentSequence);
          let seqLength = currentSequence.length;
          console.log('current sequence length: ' + seqLength);
          console.log('current sequence[first]: ' + currentSequence[0].node);
          console.log('current sequence[last]: ' + currentSequence[seqLength-1].node);
          if (currentSequence[0].node === node1 && currentSequence[seqLength-1].node === node2) {
            console.log('Trying to get way between ' + currentSequence[0].node + ' and ' + currentSequence[seqLength-1].node);
            let way = this.getWayBetweenNodes(currentSequence[0].node, currentSequence[seqLength - 1].node);
            console.log('way is ' + way);
            if (way !== null) {
              console.log('Pushing current way into result array...')
              graphsArr.push(currentSequence);
              console.log('Current graphsArr = ' + graphsArr);
            }
          }
        }
      }
      // check if it's a real way
      console.log('Trying to find real ways...')
      let resLength = graphsArr.length;
      let waysArray =[];
      for(let i = 0; i < resLength; i++){
        let isRealWay = true;
        let currentSequence = graphsArr[i];
        let curSeqLen = graphsArr[i].length;
        console.log('current sequence: ' + currentSequence + ', length = ' + curSeqLen);
        for(let j = 0; j < curSeqLen - 1; j++){
          console.log('Checking way between ' + currentSequence[j].node + ' and ' + currentSequence[j+1].node);
          if (!this.containsStraightWayFromNode1ToNode2(currentSequence[j].node, currentSequence[j+1].node,)){
            isRealWay = false;
            console.log('Is real way: ' + isRealWay);
            break;
          }
        }
        if (isRealWay){
          console.log('Real way, pushing to result array...')
          waysArray.push(currentSequence);
        }
      }
      console.log('Result array size = ' + waysArray.length);
      return waysArray;
    }

    // returns array of permutations of given array with number of sequence = k
    getPermutations(array, k){
      let m=[];
      let combinations = [];
      let indices = [];
      let len=array.length;
      function run(level){
        for(let i=0; i < len; i++){
          if(!indices[i]){
            indices[i] = true;
            combinations[level] = array[i];
            if(level < k - 1){
              run(level + 1, i + 1);
            } else {
              m.push(([]).concat(combinations));
            }
            indices[i] = false;
          }
        }
      }
      run(0);
      return m;
    }

    getRelationsMatrix() {
      console.log('Trying to build relations matrix...')

      //1. build matrix
      let size = this.nodesRelationsArray.length;
      console.log('Matrix size = ' + size)
      let matrix = [];
      for (let i = 0; i < size; i++) {
        let verticalArr = [];
        for (let j = 0; j < size; j++) {
          verticalArr.push(0);
        }
        matrix.push(verticalArr);
      }
      // 2. fill matrix
      console.log('Trying to fill relations matrix...')
      for (let i = 0; i < size; i++) {
        console.log('Iteration i = ' + i);
        let relations = this.nodesRelationsArray[i].relationsArray;
        console.log('Current relations array: ' + relations);
        let relSize = relations.length;
        console.log('Current relations array size: ' + relSize);
        for (let j = 0; j < relSize; j++) {
          console.log('Iteration j = ' + j);
          let currentNode = relations[j].node;
          console.log('Current node: ' + currentNode);
          let index = this.findNodeIndex(currentNode);
          console.log('Current index: ' + index);
          if (index !== null) {
            matrix[i][index] = relations[j].relation;
          }
        }
      }
      console.log("Filled matrix: " + matrix);
      return matrix;
    }

    // finds index of given node in nodes relations array
    findNodeIndex(node) {
      console.log('-------------------------------------------------------------------------')
      console.log('Trying to find index of node ' + node);
      for (let i = 0; i < this.nodesRelationsArray.length; i++) {
        console.log("Iterated node: " + this.nodesRelationsArray[i].node);
        if (this.nodesRelationsArray[i].node === node) {
          console.log("Index found: " + i);
          return i;
        }
        console.log("Index not found");
      }
      console.log('-------------------------------------------------------------------------')
      return null;
    }

    //returns value of relation between given nodes (order is important for oriented graph)
    getRelation(node1, node2) {
      console.log('Trying to get relations between ' + node1 + ' and ' + node2);
      for (let i = 0; i < this.nodesRelationsArray.length; i++) {
        console.log('Checking node ' + this.nodesRelationsArray[i].node);
        if (this.nodesRelationsArray[i].node === node1) {
          console.log('Coincidence found for node ' + this.nodesRelationsArray[i].node);
          let relations = this.nodesRelationsArray[i].relationsArray;
          console.log('Checking array of relations for node ' + node1 + ' to find node ' + node2);
          for (let j = 0; j < relations.length; j++) {
            if (relations[j].node === node2) {
              console.log('Node ' + node2 + ' found.');
              return relations[j].relation;
            }
          }
        }
      }
      return null;
    }

    // returns excerpt by given nodes array
    getExcerpt(nodesArr) {
      let excerpt = [];
      let size = nodesArr.length;
      for (let i = 0; i < size; i++) {
        let currentNode = nodesArr[i];
        for (let j = 0; j < this.nodesRelationsArray.length; j++) {
          if (this.nodesRelationsArray[j].node === currentNode) {
            excerpt.push(this.nodesRelationsArray[j]);
            break;
          }
        }
      }
      // deleting from relations arrays nodes which are not represented in given array
      for(let i = 0; i < excerpt.length; i++){
        let currentRelations = excerpt[i].relationsArray;
        for(let j=0; j<currentRelations.length; j++){
          let node = currentRelations[j].node;
          let isValid = false;
          for(let k=0; k < nodesArr.length; k++){
            if (nodesArr[k] === node){
              isValid = true;
              break;
            }
          }
          if (!isValid){
            currentRelations.slice(j,1);
          }
        }
      }
      return excerpt;
    }

    // finds way berween two given nodes
    // returns array of nodes (or null if no such nodes or no way between given nodes)
    getWayBetweenNodes(node1, node2) {
      console.log('/////////////////////////////////');
      console.log('Trying to get way between nodes ' + node1 + ' and ' + node2);
      if (node1 === node2) {
        console.log('Nodes are equal!');
        return [];
      }
      console.log('Current size of checked nodes = ' + this.checkedNodes.length);
      for (let i = 0; i < this.checkedNodes.length; i++) {
        console.log('checked[' + i + ']=' + this.checkedNodes[i]);
      }
      this.lastCountedWayBetweenNodes.push(node1);
      if (this.containsStraightWayFromNode1ToNode2(node1, node2)
        && this.notCheckedYet(node1)
        && this.checkedNodes.length !== this.nodesRelationsArray.length) {
        console.log('There is a straight way between ' + node1 + ' and ' + node2);
        this.checkedNodes.push(node1);
        this.lastCountedWayBetweenNodes.push(node2);
        let resultArr = this.lastCountedWayBetweenNodes.slice(0, this.lastCountedWayBetweenNodes.length);
        this.checkedNodes = [];
        this.lastCountedWayBetweenNodes = [];
        return resultArr;
      } else {
        console.log('There is NO straight way between ' + node1 + ' and ' + node2);
        this.checkedNodes.push(node1);
        let nextNodesArr = this.getNeighbours(node1);
        console.log('Neighbours for node ' + node1 + ': ' + nextNodesArr);
        if (nextNodesArr !== null) {
          let relSize = nextNodesArr.length;
          console.log('Node ' + node1 + ' has ' + relSize + ' neighbours');
          for (let i = 0; i < relSize; i++) {
            console.log('Checking node ' + nextNodesArr[i].node);
            if (this.notCheckedYet(nextNodesArr[i].node)) {
              let newNode1 = nextNodesArr[i].node;
              let resultArr = this.getWayBetweenNodes(newNode1, node2);
              if (resultArr != null) {
                return resultArr;
              }
            }
          }
        } else {
          return null;
        }
      }
    }

    // returns true if nodes are straight neighbours
    containsStraightWayFromNode1ToNode2(node1, node2) {
      console.log('Trying to find straight way between nodes ' + node1 + ' and ' + node2);
      let neighbours = this.getNeighbours(node1);
      if (neighbours == null || neighbours.length === 0) {
        console.log('Node ' + node1 + ' has no neighbours!');
        return false;
      }
      for (let i = 0; i < neighbours.length; i++) {
        if (neighbours[i].node === node2) {
          console.log('Node ' + node2 + ' is a straight neighbour of node ' + node1);
          return true;
        }
      }
      console.log('Node ' + node2 + ' is NOT a neighbour of node ' + node1);
      return false;
    }

    // checked = contains in global array of already checked nodes
    notCheckedYet(node) {
      console.log('Trying to check if node ' + node + ' already checked');
      for (let i = 0; i < this.checkedNodes.length; i++) {
        if (this.checkedNodes[i] === node) {
          console.log('Node ' + node + ' already checked!');
          return false;
        }
      }
      console.log('Node ' + node + ' is not checked yet');
      return true;
    }
  }

  console.log('************************')
  console.log('**DEBUG STARTS HERE!****')
  console.log('************************')
  let nodesRelArr = [
    {
      node          : 'node1',
      relationsArray: [
        {node: 'node2', relation: '1'},
        {node: 'node3', relation: '2'}
      ]
    },
    {
      node          : 'node2',
      relationsArray: [
        {node: 'node1', relation: '4'},
        {node: 'node4', relation: '1'}
      ]
    },
    {
      node          : 'node3',
      relationsArray: [
        {node: 'node4', relation: '2'},
        {node: 'node2', relation: '1'}
      ]
    },
    {
      node          : 'node4',
      relationsArray: []
    },
  ];

  console.log('************************')
  console.log('*****CREATE GRAPH*******')
  console.log('************************')
  let graph = new CustomGraph(nodesRelArr);
  console.log("graph:" + graph);


  console.log('************************')
  console.log('**GET RELATIONS MATRIX**')
  console.log('************************')
  let matrix = graph.getRelationsMatrix();
  console.log("matrix: " + matrix);

  console.log('************************')
  console.log('*****GET NEIGHBOURS*****')
  console.log('************************')
  let neighbours = graph.getNeighbours('node2');
  console.log("neighbours: " + neighbours);

  console.log('************************')
  console.log('******ADD NEW NODE******')
  console.log('************************')
  let newNode = {
    node          : 'node5',
    relationsArray: [
      {node: 'node1', relation: '2'}
    ]
  };
  graph.addNewNode(newNode);

  let addedNode = graph.getNode('node5');
  console.log('added node: ' + addedNode.node);
  console.log('added node relations size: ' + addedNode.relationsArray.length);

  console.log('************************')
  console.log('******DELETING NODE*****')
  console.log('************************')
  let newNode2 = {
    node          : 'node6',
    relationsArray: [
      {node: 'node5', relation: '4'}
    ]
  };
  graph.addNewNode(newNode2);
  let addedNode2 = graph.getNode('node6');
  console.log('added node: ' + addedNode2.node);
  console.log('added node relations size: ' + addedNode2.relationsArray.length);

  let deletedNode = graph.deleteNode('node6');
  console.log('deleted at least once: ' + deletedNode);
  console.log('changed nodes: ' + graph.getNodesRelationsArray());

  console.log('************************')
  console.log('*****ADD NEW RELATION***')
  console.log('************************')
  graph.addNewRelation('node4', 'node5', '1');

  let newMatrix = graph.getRelationsMatrix();
  console.log("new matrix: " + newMatrix);

  console.log('************************')
  console.log('**GET NODES&RELATIONS***')
  console.log('************************')
  let relationsArr = graph.getNodesRelationsArray();
  console.log("rels: " + relationsArr);


  console.log('************************')
  console.log('******DELETE RELATION***')
  console.log('************************')
  graph.addNewRelation('node1', 'node4', '5');
  console.log("added relation: " + graph.getNodesRelationsArray()[0].relationsArray);

  let deletedRel = graph.deleteRelation('node1', 'node4', '5');
  console.log('deleted at least once: ' + deletedRel);
  console.log("changed relations: " + graph.getNodesRelationsArray()[0].relationsArray);


  console.log('************************')
  console.log('*******GET RELATION*****')
  console.log('************************')
  let relation = graph.getRelation('node3', 'node4');
  console.log('relation = ' + relation);

  console.log('************************')
  console.log('*******GET EXCERPT******')
  console.log('************************')
  let nodesArr = ['node1', 'node2'];
  let excerpt = graph.getExcerpt(nodesArr);
  console.log('excerpt: ' + excerpt);
  console.log('ex[0]=' + excerpt[0].node);
  console.log('ex[1]=' + excerpt[1].node);
  let graph2 = new CustomGraph(excerpt);
  let excerptMatrix = graph2.getRelationsMatrix();
  console.log('excerpt matrix: ' + excerptMatrix);

  console.log('************************')
  console.log('*********GET WAY********')
  console.log('************************')
  let way = graph.getWayBetweenNodes('node1', 'node5');
  console.log('way = ' + way);

  console.log('************************')
  console.log('*******EXPAND GRAPH*****')
  console.log('************************')
  let expanded = graph.expandGraph('node1', 'node5');
  console.log('expanded graph size: ' + expanded.length);
  for(let i=0; i< expanded.length; i++){
    console.log('Nodes of new graph:');
    for(let j = 0; j < expanded[i].length; j++){
      console.log('sequence['+j+']=' + expanded[i][j].node);
    }
  }
  console.log('************************');
  console.log('******END OF DEBUG *****');
  console.log('************************');
</script>

</body>
</html>